class ChangeablePlayer {
    int x;
    int y;
    int rad; // radius
    int lives;
    long lastHit;
    PImage sprite;
    
    ChangeablePlayer(int x, int y){
        this.x = x;
        this.y = y;
        lives = /* EDIT VALUE */;
        rad = 18;
        lastHit = 0;
        sprite = loadImage("player.png");
    }
    boolean hitByProj(){ 
        for (int[] i : projectiles) { // Check to see if circles intersect for every projectile. We should stop loading them when they disappear
            if (dist(x, y, i[0], i[1]) < rad + i[3]){
                return true;
            }
        }
        return false;
    }
    
    void updatePlayer(){
      movePlayer();
      drawPlayer();
      if (hitByProj() && msElapsed >= lastHit+2000){
        loseLife();
      }
      textSize(12);
      text("LIVES: "+lives, 800, 100);
    }
    
    void drawPlayer(){
        if (msElapsed < lastHit+2000 && ((lastHit+2000-msElapsed)/125)%2==0) tint(255, 127); //Show i-frames through blinking player
        image(sprite,x,y);
        tint(255, 255);
    }
    
    void movePlayer(){
      if (moveKeys[0] && y>=5){ // w = up
        y-= /* EDIT VALUE */;
      }
      if (moveKeys[1] && height-y>=41){ // s = down
        y+= /* EDIT VALUE */;
      } 
      if (moveKeys[2] && x>=5){ // a = left
        x-= /* EDIT VALUE */;
      } 
      if (moveKeys[3] && width-x>=59){ // d = right
        x+= /* EDIT VALUE */;
      } 
    }
    
    void loseLife(){ // Make player invulnerable for a time
        lives -= 1;
        lastHit = msElapsed;
        if (lives == 0) {
            gameOver = true;
        }
    }
}
