int level = 0;
boolean gameOver = false;

boolean[] moveKeys = new boolean[4];  // w=0, s=1, a=2, d=3
// Player player = new Player(35, 35);
ChangeablePlayer player;
PImage bckgd, snowballSmall, snowballMedium, snowballLarge;


void setup() {
    size(900,600);
    frameRate(60);
    bckgd = loadImage("bckgd.png");
    player = new ChangeablePlayer(width/2-15, height/2-15);
    snowballSmall = loadImage("snowballsmall.png");
    snowballMedium = loadImage("snowballmedium.png");
    snowballLarge = loadImage("snowballlarge.png");
    
}


void draw() {
    clear();
    timeHandler();
    //fill(#B9B9B9);
    //rect(0,0,width,height);
    image(bckgd,0,0);
    levelHandler();
    if(timerStarted && !gameOver){ //game in play
        text("Time: "+(int)(msElapsed-savedTime)/1000,100,100);
        player.updatePlayer();
        updateProjectiles();
    }else{ //game not in play (either timer not started or player has lost all 3 lives)
      if(!gameOver){ // game is not over, so timer has not started yet -- display game start screen
        fill(#B9B9B9);
        rect(0,0,width,height);
        fill(#000000);
        textSize(20);
        textAlign(CENTER);
        text("Press Space to begin",450,300);
      }else{ //player has lost all 3 lives -- display game over screen
        fill(#B9B9B9);
        rect(0,0,width,height);
        fill(#000000);
        textSize(20);
        textAlign(CENTER);
        text("Game Over!",450,300);
      }
    }
}

void keyPressed(){
    if(key == ' '){
        if(!timerStarted){
            timerStarted = true;
            savedTime = msElapsed;
        }
        /*else if(timerStarted){
            timerStarted = false;
            println(msElapsed-savedTime + " milliseconds have passed.");
        }*/
    }
    if (key == 'w' || key == UP)
      moveKeys[0] = true;
    if (key == 's' || key == DOWN)
      moveKeys[1] = true;
    if (key == 'a' || key == LEFT)
      moveKeys[2] = true;
    if (key == 'd' || key == RIGHT)
      moveKeys[3] = true;
}

void keyReleased() {
  if (key == 'w' || key == UP)
    moveKeys[0] = false;
  if (key == 's' || key == DOWN)
    moveKeys[1] = false;
  if (key == 'a' || key == LEFT)
    moveKeys[2] = false;
  if (key == 'd' || key == RIGHT)
    moveKeys[3] = false;
}
