// x, y, velocity, radius
ArrayList<int[]> projectiles = new ArrayList<int[]>();

void updateProjectiles() {
    generateProjectile();
  
    for (int i = projectiles.size() - 1; i >= 0; i--) {  // loop through each projectile
        drawProjectile(projectiles.get(i));  // draw the projectile
        moveProjectile(projectiles.get(i));  // move the projectile
    }
}

void moveProjectile(int[] projectile) {
    projectile[0] += projectile[2];  // add it's velocity to it's x position
    
    if (projectile[0] < - 10 || projectile[0] > width + 10)  // if it goes off the screen, delete it
        projectiles.remove(projectile);
}

void drawProjectile(int[] projectile) {
    //ellipse(projectile[0], projectile[1], projectile[3] * 2, projectile[3] * 2);
    if(projectile[3]==6) image(snowballSmall,projectile[0],projectile[1]);
    else if(projectile[3]==11) image(snowballMedium,projectile[0],projectile[1]);
    else if(projectile[3]==18) image(snowballLarge,projectile[0],projectile[1]);
}
